function [rera_1step,rera_2step]=do_experiment_fullAAHu_preselectionOCMT(P,N,Ts, Data, Wo)
%(P,N,T, Data1, NaN, sp);
%% initialize output

rera_1step.MSE=0;
rera_1step.bias=0;
rera_1step.R2=0;
rera_1step.itr=0;
rera_1step.size=0;
rera_1step.power=zeros(P.jp,1);

rera_1step.spdy=zeros(21,21);
rera_1step.spth=zeros(21,21);

rera_1step.size1=0;
rera_1step.power1=zeros(P.jp,1);
rera_1step.size2=0;
rera_1step.power2=zeros(P.jp,1);
rera_1step.size3=0;
rera_1step.power3=zeros(P.jp,1);

rera_2step=rera_1step;
rera_cu=rera_1step;
rer_2sa=rera_cu;
rer_2sb=rera_cu;

T=Ts-1;

%% estimations - general
K=(T-2)*(T-1)/2+(T-2); % number of moment conditions

% define Sample Moment Conditions
%m=m0-phi*m1+pji*m2
m0=zeros(K,1); m0i=zeros(K,N); 
m1=zeros(K,1); m1i=zeros(K,N); 
m2=zeros(K,1); m2i=zeros(K,N); 

k=0;
dy=Data.dY;
for s=2:T-1
    for t=s+1:T
        k=k+1;
        % moment dy_i,t-s * (dy_i,t-phi* dy_i,t-1)
        m0i(k,:)=dy(:,t-s).*dy(:,t);
        m1i(k,:)=dy(:,t-s).*dy(:,t-1);
        m0(k,1)=sum(dy(:,t-s).*dy(:,t))/N;
        m1(k,1)=sum(dy(:,t-s).*dy(:,t-1))/N;
    end
end
% now augment with BMM moments

for t=2:T-1
    k=k+1;
    m0i(k,:)=dy(:,t).*dy(:,t-1)+dy(:,t).*dy(:,t)+dy(:,t+1).*dy(:,t);
    m0(k,1)=m0i(k,:)*ones(N,1)/N;
    m1i(k,:)=dy(:,t-1).*dy(:,t-1)+2*dy(:,t).*dy(:,t-1)+dy(:,t).*dy(:,t);
    m1(k,1)=m1i(k,:)*ones(N,1)/N;
    m2i(k,:)=dy(:,t-1).*dy(:,t-1);
    m2(k,1)=m2i(k,:)*ones(N,1)/N;
end

%% now conduct pre-selection
% pre-selection is done on AH moment with s>2 only
% these are the moments k=T-1,T-2,... (T-2)*(T-1)/2
sind=false(1,K);

% select moments first
itr=zeros(T-3,1);
for t=4:T
   indsearch=false(T,1);
   indsearch(1:t-3,1)=true;
   Xcond=dy(:,t-2);
   X=dy(:,indsearch);
   y=dy(:,t-1);
   pval=0.05; delta1=1; delta2=2;
   [inds, itr(t-3)] = OCMT_sel(y,X,Xcond, pval, delta1, delta2 );
  % inds=indsearch;
   % s=t-1,...,3
   % now assign selected moments
   k=0;
   for s=2:T-1
     for tt=s+1:T
        k=k+1;
        if t==tt && s>2
            sind(1,k)=inds(t-s);
        end
     end
   end
   
end

% now add remaining moments
ind1=false(1,K);
ind1(1:T-2)=true;
ind1((T-2)*(T-1)/2+1:K)=true;

indu=sind | ind1;
Kr=sum(indu);

m0r=m0(indu);
m1r=m1(indu);
m2r=m2(indu);

% 1-step estimator
os = optimset('LargeScale','off','MaxFunEvals',10^5,'MaxIter',10^5,'TolX',1e-8);
options = optimset('Display','off', 'TolX',1e-6);%
lq = -2;
uq = 2;
stphi=0;
w1=Wo.aah1;
W1=w1*w1';

Wr=W1(indu,indu);
w1r=w1(indu);
str=evalc('[para,obj,ef, output]=fminunc(@objg_12step,stphi,options,m0r,m1r,m2r, Wr)');
phi_1stepcheck=para;

%phi_1step=w1'*m0/(w1'*m1);

% alternative
%m0-phi*m1+phi^2*m2
Dtmnt=(w1r'*m1r)^2-4*(w1r'*m2r)*(w1r'*m0r);
if Dtmnt>=0
    x1=(w1r'*m1r+Dtmnt^0.5)/2/(w1r'*m2r);
    x2=(w1r'*m1r-Dtmnt^0.5)/2/(w1r'*m2r);
    % now select root
    a1=m0r-x1*m1r+x1^2*m2r;
    a2=m0r-x2*m1r+x2^2*m2r;
    na1=a1'*a1;
    na2=a2'*a2;
    if na1<na2
        phi_1step=x1;
    else
        phi_1step=x2;
    end
end
if Dtmnt<0
    phi_1step=w1r'*m1r/(w1r'*m2r)/2;
end



% 2-step estimator

S=zeros(Kr,Kr); sm=zeros(Kr,1);
Sa=zeros(Kr,Kr); Sb=zeros(Kr,Kr); Sc=zeros(Kr,Kr); Sd=zeros(Kr,Kr); Se=zeros(Kr,Kr);
A=zeros(N,Kr);
for i=1:N
   a=m0i(indu,i)-phi_1step*m1i(indu,i)+(phi_1step^2)*m2i(indu,i);
   Si= a*a';
   sm=sm+a/N;
   A(i,:)=a';
   S=S+Si;
   Sia=m0i(indu,i)*m0i(indu,i)';
   Sib=-m0i(indu,i)*m1i(indu,i)'-m1i(indu,i)*m0i(indu,i)';
   Sic=m1i(indu,i)*m1i(indu,i)'+m2i(indu,i)*m0i(indu,i)'+m0i(indu,i)*m2i(indu,i)';
   Sid=-m2i(indu,i)*m1i(indu,i)'-m1i(indu,i)*m2i(indu,i)';
   Sie=m2i(indu,i)*m2i(indu,i)';
   Sa=Sa+Sia;
   Sb=Sb+Sib;
   Sc=Sc+Sic;
   Sd=Sd+Sid;
   Se=Se+Sie;
end
S1=S/N;
Sa=Sa/N;
Sb=Sb/N;
Sc=Sc/N;
Sd=Sd/N;
Se=Se/N;

%Salt=Sa+phi_1step*Sb+(phi_1step^2)*Sc+(phi_1step^3)*Sd+(phi_1step^4)*Se;

W2=pinv(S1-sm*sm');
W=W2;
if abs(phi_1step)<1
    stphi=phi_1step;
else
    stphi=0;
end
str=evalc('[para,obj,ef, output]=fminunc(@objg_12step,stphi,options,m0r,m1r,m2r, W)');
phi_2step=para;

% %rer2sa
%   p=K/(N^0.5+K-1);
%   wo=W2*(-m1+2*phi_1step*m2);
%   wo=wo/(sum(wo));
%   [~,ind]=min(abs(Wo.phi_range-phi_1step));
%   ws=Wo.aah{ind};
%   wa=(1-p)*wo+p*ws;
%   
% Dtmnt=(wa'*m1)^2-4*(wa'*m2)*(wa'*m0);
% if Dtmnt>=0
%     x1=(wa'*m1+Dtmnt^0.5)/2/(wa'*m2);
%     x2=(wa'*m1-Dtmnt^0.5)/2/(wa'*m2);
%     % now select root
%     a1=m0-x1*m1+x1^2*m2;
%     a2=m0-x2*m1+x2^2*m2;
%     na1=a1'*a1;
%     na2=a2'*a2;
%     if na1<na2
%         phi_2stepa=x1;
%     else
%         phi_2stepa=x2;
%     end
% end
% if Dtmnt<0
%     phi_2stepa=wa'*m1/(wa'*m2)/2;
% end
% 
%  % rer2sb
%   lambda=K/(N^0.5);
%   [~,ind]=min(abs(Wo.phi_range-phi_1step));
%   ws=Wo.aah{ind};
%   sc=mean(diag(S1'*S1));
%   d=-m1+2*phi_1step*m2;
%   sc2=sum(pinv(S1)*d);
%   wb=inv(S1'*S1+lambda*sc*eye(K))*(S1'*d/sc2+lambda*sc*ws);
% 
%   
%   Dtmnt=(wb'*m1)^2-4*(wb'*m2)*(wb'*m0);
% if Dtmnt>=0
%     x1=(wb'*m1+Dtmnt^0.5)/2/(wb'*m2);
%     x2=(wb'*m1-Dtmnt^0.5)/2/(wb'*m2);
%     % now select root
%     a1=m0-x1*m1+x1^2*m2;
%     a2=m0-x2*m1+x2^2*m2;
%     na1=a1'*a1;
%     na2=a2'*a2;
%     if na1<na2
%         phi_2stepb=x1;
%     else
%         phi_2stepb=x2;
%     end
% end
% if Dtmnt<0
%     phi_2stepb=wb'*m1/(wb'*m2)/2;
% end
%   
%   

% % rerd - estimate S1
%  %S1d=mt_est(A, 0.1, 2);
%  S1d=diag(diag(S1));
%  W2d=pinv(S1d);
%  W=W2d;
%  str=evalc('[para,obj,ef, output]=fminunc(@objg_12step,stphi,options,m0,m1,m2, W)');
%  phi_2d=para;
%  
 
% % CU estimator
% os = optimset('LargeScale','off','MaxFunEvals',10^5,'MaxIter',10^5,'TolX',1e-8);
% options = optimset('Display','off', 'TolX',1e-6);%
% if abs(phi_2step)<1
%     stphi=phi_2step;
% else
%     stphi=0;
% end
% str=evalc('[para,obj,ef, output]=fminunc(@objg,stphi,options,m0,m1,m2, Sa,Sb,Sc,Sd,Se)');
% phi_cu=para;


% now asymptotic variance
D1=-m1r+2*phi_1step*m2r;
av_1step=pinv(D1'*Wr*D1)*D1'*Wr*S1*Wr'*D1*pinv(D1'*Wr*D1);
D2=-m1r+2*phi_2step*m2r;
av_2step=pinv(D2'*pinv(S1-sm*sm')*D2);
% %D2d=-m1+2*phi_2d*m2;
% %av_2dstep=pinv(D2d'*pinv(S1d)*D2d);

% av_2stepa=(wa'*S1*wa)/((wa'*d)^2);
% av_2stepb=(wb'*S1*wb)/((wb'*d)^2);
% 
% 
% Dcu=-m1+2*phi_cu*m2;
% Scu=Sa+phi_cu*Sb+(phi_cu^2)*Sc+(phi_cu^3)*Sd+(phi_cu^4)*Se;
% av_cu=pinv(Dcu'*pinv(Scu)*Dcu);
% 

%% now report rer structure
varc=av_1step/N;
rera_1step=reportrer(rera_1step,phi_1step,varc, Data, P,Kr, NaN, mean(itr)); 

varc=av_2step/N;
rera_2step=reportrer(rera_2step,phi_2step,varc, Data, P,Kr, NaN, mean(itr));

% % varc=av_2dstep/N;
% % rerd=reportrer(rerd,phi_2d,varc, Data, P);
% 
% varc=av_2stepa/N;
% rer_2sa=reportrer(rer_2sa,phi_2stepa,varc, Data, P);
% varc=av_2stepb/N;
% rer_2sb=reportrer(rer_2sb,phi_2stepb,varc, Data, P);
% 
% 
% varc=av_cu/N;
% rera_cu=reportrer(rera_cu,phi_cu,varc, Data, P); 
return % function


%% declare functions

function obj=objg_12step(phi,m0,m1, m2, W)

% get params from psi
m=m0-phi*m1+phi*phi*m2;

obj=m'*W*m;

return

function obj=objg(phi,m0,m1,m2, Sa,Sb,Sc,Sd,Se)

% get params from psi
m=m0-phi*m1+phi*phi*m2;
S=Sa+phi*Sb+(phi^2)*Sc+(phi^3)*Sd+(phi^4)*Se;

obj=m'*pinv(S)*m;

return