% This script submits cluster jobs for the panel AR Monte Carlo experiments in the paper "An Augmented Anderson-Hsiao Estimator
% for Dynamic Short-T Panels" by A. Chudik and M.H. Pesaran, March 23, 2021.

%% preliminaries
c=parcluster('bigtex R2019a'); % select cluster - please choose one that is available to you
c.AdditionalProperties.QueueName = 'normal'; % choose your cluster queue name 
c.AdditionalProperties.WallTime= '';
clstr_results_folder='/results'; % choose your desired folder on the cluster for saving results

totalNumberofWorkers=8*16; % chosen number of workers (can be set depending on the cluster hardware)

%% job submission
exp=[1,2,4];
phis=[0.4,0.6,0.8,0.9];

for experiments=exp
    for phi0=phis
        [experiments, phi0]
        job=batch(c, 'mc_simul_f', 'Pool', totalNumberofWorkers-1, 'EnvironmentVariables', 'env','CurrentFolder', clstr_results_folder);    
    end
end

disp('Job submission script ended - please check cluster for further info...')
disp ('When jobs are finished, copy saved results from the chosen folder on the cluster')
disp('(chosen on line 8) back to Matlab workpsace, and run save_from_cluster_ARF.m ')
disp('for saving the selected results from mat files into Excel files.')
